#include "oslib/os.h"
#include "oslib/wimp.h"

const char *Initialise (void);
void findMachineType (void);
const char *SelMode (int res);

int mm_keyb_pressed (int);

void openwindow (void *);	/* wimp_open* */
int areyousure (int);

void godesktop (void);
void goshutdown (void);

int initmusic (const void *music);
int initsfx (int nomusic);

void musicPlay (int from, int to, int keyboard);
void musicPlayB (int from, int to, int keyboard, int play);
void musicPause (int);
void musicVolume (void);
void UpdatePianoKeys (void);

int module_present (const char *module);
os_error *uriDispatch (const char *uri, wimp_t me);
int uriRequest (char *uri, int len, int handle);


extern int modedata[];

extern int wavpitch[2];
extern char wavsample[2];
extern int wavlen[2];

extern int samplefreq;
extern struct
{
  int voices;
  int buflen;
  int period;
}
config;

typedef struct sampleInfo
{
  const void *ptr, *end;
  long repeat;
}
sampleInfo;

extern sampleInfo sampleptr[4];
extern const void *volenvptr[4];

extern int hires;
extern int hires_ok;

extern char SOUND;
extern int VOLUME;

extern int machinetype;		/* 0=ARM2, 1=ARM3, 2=ARM6/ARM7, 3=SA */
extern int using_16bit;		/* sound */

#define isHiRes() (hires && machinetype>1)

#define PlotPixel(x,y,c) \
  { \
    if (hires && machinetype>1) { \
      BYTE *_b=&display[0][(y)*2][(x)]; \
      _b[320]=_b[0]=(c); \
    } else \
      display[0][(y)][(x)]=(c); \
  }

#define PlotPixelHi(x,y,c) \
  { BYTE *_b=&display[0][(y)*2][(x)]; _b[320]=_b[0]=(c); }

#define PlotPixelLo(x,y,c) display[0][(y)][(x)]=(c); \

#define GetPixel(x,y) \
  (display[0][(y)*((hires && machinetype>1) ? 2 : 1)][x])

#define GetPixelHi(x,y) (display[0][(y)*2][x])

#define GetPixelLo(x,y) (display[0][y][x])

#define PlotPixelRow(x,y,buf,len) \
  { \
    if (hires && machinetype>1) { \
      BYTE *_b=&display[0][(y)*2][(x)]; \
      const BYTE *_buf=(buf); \
      int _len=(len); \
      memcpy(_b,_buf,_len); \
      memcpy(_b+320,_buf,_len); \
    } else \
      memcpy(&display[0][(y)][(x)],(buf),(len)); \
  }

#define PlotBGPixelRow(x,y,colour,len) \
  { \
    if (hires && machinetype>1) { \
      BYTE *_b=&display[0][(y)*2][(x)]; \
      int _len=(len), _colour=(colour); \
      memset(_b,_colour,_len); \
      memset(_b+320,_colour,_len); \
    } else \
      memset(&display[0][(y)][(x)],(colour),(len)); \
  }

int (isHiRes) (void);
