R0	RN	0
R1	RN	1
R2	RN	2
R3	RN	3
R4	RN	4
R5	RN	5
R6	RN	6
R7	RN	7
R8	RN	8
R9	RN	9
R10	RN	10
R11	RN	11
R12	RN	12
R13	RN	13
R14	RN	14
PC	RN	15

DMASIZE	*	2048

	IMPORT	exit
	IMPORT	__rt_stkovf_split_small

;	IMPORT	speed
	IMPORT	SPEED
	IMPORT	wimp_v
	IMPORT	old	; int
	IMPORT	GFXpkeys
	IMPORT	VidMode


	EXPORT	Initialise
	EXPORT	findMachineType
	EXPORT	SelMode
	EXPORT	openwindow
	EXPORT	areyousure
	EXPORT	goshutdown
	EXPORT	godesktop
	EXPORT	initmusic
	EXPORT	initsfx
	EXPORT	musicPlay
	EXPORT	musicPlayB
	EXPORT	musicPause
	EXPORT	musicVolume

	EXPORT  mm_keyb_pressed
	EXPORT  mm_keyb_update

	EXPORT	mm_snd_getmodpos
	EXPORT	mm_snd_active

	EXPORT	modedata
	EXPORT	last_cls

	EXPORT	wavpitch	; long[2]
	EXPORT	wavsample	; char[2] ; sample number
	EXPORT	wavlen		; char[2] ; volume level
	EXPORT	sampleptr	; struct { char* ptr, end; long rep; }[4]
	EXPORT	samplefreq
	EXPORT	using_16bit

	EXPORT	SOUND
	EXPORT	VOLUME

	EXPORT	hires
	EXPORT	hires_ok
	EXPORT	HiRes
	EXPORT	LoRes
	EXPORT	videoram
	EXPORT	bank
	EXPORT	localpalette
	EXPORT	paletteflag

	EXPORT	machinetype

	EXPORT	module_present
	EXPORT	uriDispatch
	EXPORT	uriRequest


	EXPORT	mm_gfx_setdirty

	EXPORT	mm_gfx_putpixel
	EXPORT	mm_gfx_getpixel
	EXPORT	mm_gfx_cls
	EXPORT	mm_gfx_flush
	EXPORT	mm_gfx_waitvr
	EXPORT	mm_gfx_fillbox
	EXPORT	mm_gfx_palset

	EXPORT	mm_snd_hitpianokeys

	EXPORT	PlotXY
	EXPORT	PlotXYmask
	EXPORT	PlotXYink
	EXPORT	PlotXYmask_ink
	EXPORT	PlotShiny
;	EXPORT	GetRect

	EXPORT	RotPal2
	EXPORT	FadeToBlue

	EXPORT	display
	EXPORT	dirty


	GBLS	StackedRegs
	GBLS	_HAT

	[ :LNOT: :DEF: ARM32
_HAT	SETS	"^"
	]

	MACRO
$la	FNJSR $a
StackedRegs SETS "$a"
$la
	[ StackedRegs=""
	STMFD R13!,{R14}
	|
	STMFD R13!,{$StackedRegs,R14}
	]
	MEND

	MACRO
$la	FNRTS $cc
$la
	[ StackedRegs=""
	LDM$cc.FD R13!,{PC}$_HAT
	|
	LDM$cc.FD R13!,{$StackedRegs,PC}$_HAT
	]
	MEND

	MACRO
$la	FNPULL $cc
$la
	[ StackedRegs=""
	LDM$cc.FD R13!,{R14}
	|
	LDM$cc.FD R13!,{$StackedRegs,R14}
	]
	MEND

	AREA	|Asm$$Code|, CODE, READONLY


; Handles an array of 32*24 character cells.
; 'Set' cells are dirty and will need to be redisplayed.
; UNLESS OTHERWISE SPECIFIED, THE ROUTINES BELOW CALL THIS ONE.
; Input: x, y, width, height (in pixels)
mm_gfx_setdirty ROUT
	FNJSR	"R4"
	AND	R14,R0,#7
	ADD	R2,R2,R14
	AND	R14,R1,#7
	ADD	R3,R3,R14
	LDR	R14,=dirty
	BIC	R1,R1,#7
	ADD	R14,R14,R1,LSL #2
	ADD	R14,R14,R0,LSR #3
	ADD	R2,R2,#7
	BICS	R2,R2,#7
	ADDNE	R3,R3,#7
	BICNES	R3,R3,#7
	FNRTS	EQ
	MOV	R0,#1
0	MOV	R1,R2
	MOV	R4,R14
1	STRB	R0,[R4],#1
	SUBS	R1,R1,#8
	BNE	%BT1
	ADD	R14,R14,#32
	SUBS	R3,R3,#8
	BNE	%BT0
	FNRTS


; Plots a single pixel. Note that this does *not* call mm_gfx_setdirty.
; Input: x, y, colour
mm_gfx_putpixel ROUT
	LDR	R3,=display
	ADD	R0,R0,R1,LSL #8
	LDR	R3,[R3]
	STRB	R2,[R3,R0]
	MOVS	PC,R14


; Reads a single pixel. (No screen update is required.)
; Input: x, y, colour
mm_gfx_getpixel ROUT
	LDR	R3,=display
	ADD	R0,R0,R1,LSL #8
	LDR	R3,[R3]
	LDRB	R0,[R3,R0]
	MOVS	PC,R14


; Clears the whole screen.
; Input: colour
mm_gfx_cls ROUT
	FNJSR	"R4-R9"
	LDR	R1,=last_cls
	STR	R0,[R1]
	LDR	R8,=display
	MOV	R14,#256*192
	LDR	R8,[R8]
	ORR	R0,R0,R0,LSL #8
	ORR	R0,R0,R0,LSL #16
	MOV	R1,R0
	MOV	R2,R0
	MOV	R3,R0
	MOV	R4,R0
	MOV	R5,R0
	MOV	R6,R0
	MOV	R7,R0
0	STMIA	R8!,{R0-R7}
	SUBS	R14,R14,#32
	BNE	%BT0
	LDR	R0,=dirty
	MOV	R1,#768
	MVN	R2,#0
4	STR	R2,[R0],#4
	SUBS	R1,R1,#4
	BNE	%BT4
	; Now do the border...
	LDR	R8,=videoram
	LDR	R8,[R8]
	TEQ	R8,#0
	FNRTS	EQ
	LDR	R1,=machinetype
	LDR	R0,=last_cls
	LDR	R1,[R1]
	CMP	R1,#2
	LDR	R0,[R0]
	LDRLO	R1,=localpalette
	LDRLOB	R0,[R1,R0]
	ORR	R0,R0,R0,LSL #8
	ORR	R0,R0,R0,LSL #16
	MOV	R1,R0
	MOV	R2,R0
	MOV	R3,R0
	MOV	R4,R0
	MOV	R5,R0
	MOV	R6,R0
	MOV	R7,R0
	LDR	R9,=hires
	LDR	R9,[R9]
	TEQ	R9,#0
	LDREQ	R14,=LoRes
	LDRNE	R14,=HiRes
	LDR	R14,[R14,#4]	; offset *to* top left
	SUB	R8,R8,R14
	MOVEQ	R14,#4*8*2	; plot just border...
	MOVNE	R14,#6*8*2
1	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	SUBS	R14,R14,#1
	BNE	%BT1
	TEQ	R9,#0
	MOVEQ	R14,#192
	MOVNE	R14,#384
2	STMIA	R8!,{R0-R7}
	ADD	R8,R8,#256
	STMIA	R8!,{R0-R7}
	SUBS	R14,R14,#1
	BNE	%BT2
	TEQ	R9,#0
	MOVEQ	R14,#4*8*2	; plot just border...
	MOVNE	R14,#6*8*2
3	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	STMIA	R8!,{R0-R7}
	SUBS	R14,R14,#1
	BNE	%BT3
	FNRTS


	MACRO
	FNlookup
	LDRB	R10,[R2,R9,LSR #24]
	MOV	R9,R9,ROR #24
	LDRB	R12,[R2,R9,LSR #24]
	ORR	R10,R12,R10,LSL #8
	MOV	R9,R9,ROR #24
	LDRB	R12,[R2,R9,LSR #24]
	ORR	R10,R12,R10,LSL #8
	MOV	R9,R9,ROR #24
	LDRB	R12,[R2,R9,LSR #24]
	ORR	R10,R12,R10,LSL #8
	MEND


mm_gfx_flush ROUT
	FNJSR	"R4-R10"
	LDR	R0,=machinetype
	LDR	R0,[R0]
	CMP	R0,#2
	LDR	R0,=display
	LDR	R1,=videoram
	LDR	R3,=hires
	LDR	R0,[R0]
	LDR	R1,[R1]
	LDR	R3,[R3]
	BHS	simple_blat
; Translation blat for fixed palette machines
	LDR	R2,=localpalette
	TEQ	R3,#0
	LDR	R3,=dirty
	MOV	R4,#24
	BNE	complex_blat_hires
0	MOV	R5,#32
1	LDRB	R6,[R3],#1
	TEQ	R6,#0
	ADDEQ	R0,R0,#8
	ADDEQ	R1,R1,#8
	BEQ	%FT3
	MOV	R6,#0
	STRB	R6,[R3,#-1]
	MOV	R7,#8
2	LDR	R9,[R0,#4]
	FNlookup
	STR	R10,[R1,#4]
	LDR	R9,[R0],#256
	FNlookup
	STR	R10,[R1],#320
	SUBS	R7,R7,#1
	BNE	%BT2
	SUB	R0,R0,#256*8
	ADD	R0,R0,#8
	SUB	R1,R1,#320*8
	ADD	R1,R1,#8
3	SUBS	R5,R5,#1
	BNE	%BT1
	ADD	R0,R0,#&700
	ADD	R1,R1,#&900
	SUBS	R4,R4,#1
	BNE	%BT0
	FNPULL
	B	mm_gfx_waitvr
complex_blat_hires ROUT
0	MOV	R5,#32
1	LDRB	R6,[R3],#1
	TEQ	R6,#0
	ADDEQ	R0,R0,#8
	ADDEQ	R1,R1,#8
	BEQ	%FT3
	MOV	R6,#0
	STRB	R6,[R3,#-1]
	MOV	R7,#8
2	LDR	R9,[R0,#4]
	FNlookup
	STR	R10,[R1,#4]
	STR	R10,[R1,#324]
	LDR	R9,[R0],#256
	FNlookup
	STR	R10,[R1,#320]
	STR	R10,[R1],#640
	SUBS	R7,R7,#1
	BNE	%BT2
	SUB	R0,R0,#256*8
	ADD	R0,R0,#8
	SUB	R1,R1,#640*8
	ADD	R1,R1,#8
3	SUBS	R5,R5,#1
	BNE	%BT1
	ADD	R0,R0,#&700
	ADD	R1,R1,#&1300
	SUBS	R4,R4,#1
	BNE	%BT0
	FNPULL
	B	mm_gfx_waitvr
simple_blat
	TEQ	R3,#0
	LDR	R3,=dirty
	MOV	R4,#24
	BNE	simple_blat_hires
0	MOV	R5,#32
1	LDRB	R6,[R3],#1
	TEQ	R6,#0
	ADDEQ	R0,R0,#8
	ADDEQ	R1,R1,#8
	BEQ	%FT3
	MOV	R6,#0
	STRB	R6,[R3,#-1]
	MOV	R7,#8
2	LDMIA	R0,{R9,R10}
	STMIA	R1,{R9,R10}
	ADD	R0,R0,#256
	ADD	R1,R1,#320
	SUBS	R7,R7,#1
	BNE	%BT2
	SUB	R0,R0,#256*8
	ADD	R0,R0,#8
	SUB	R1,R1,#320*8
	ADD	R1,R1,#8
3	SUBS	R5,R5,#1
	BNE	%BT1
	ADD	R0,R0,#&700
	ADD	R1,R1,#&900
	SUBS	R4,R4,#1
	BNE	%BT0
	FNPULL
	B	mm_gfx_waitvr
simple_blat_hires ROUT
0	MOV	R5,#32
1	LDRB	R6,[R3],#1
	TEQ	R6,#0
	ADDEQ	R0,R0,#8
	ADDEQ	R1,R1,#8
	BEQ	%FT3
	MOV	R6,#0
	STRB	R6,[R3,#-1]
	MOV	R7,#8
2	LDMIA	R0,{R9,R10}
	STMIA	R1,{R9,R10}
	ADD	R0,R0,#256
	ADD	R1,R1,#320
	STMIA	R1,{R9,R10}
	ADD	R1,R1,#320
	SUBS	R7,R7,#1
	BNE	%BT2
	SUB	R0,R0,#256*8
	ADD	R0,R0,#8
	SUB	R1,R1,#640*8
	ADD	R1,R1,#8
3	SUBS	R5,R5,#1
	BNE	%BT1
	ADD	R0,R0,#&700
	ADD	R1,R1,#&1300
	SUBS	R4,R4,#1
	BNE	%BT0
	FNPULL
	; fall through


mm_gfx_waitvr ROUT
	LDR	R2,=SPEED;speed
	LDR	R3,=time
	LDRB	R2,[R2]
	LDR	R3,[R3]
0	SWI	&42 ; OS_ReadMonotonicTime
	SUB	R1,R0,R3
	CMP	R1,R2
	BLO	%BT0
	LDR	R3,=time
	STR	R0,[R3]
	MOVS	PC,R14


; Plots a filled rectangle of arbitrary size.
; Input: x, y, width, height, colour
mm_gfx_fillbox	ROUT
	FNJSR	"R0-R6"
	LDR	R5,=display
	LDR	R5,[R5]
	LDR	R4,[R13,#32]
	TEQ	R5,#0
	FNRTS	EQ
	BL	mm_gfx_setdirty
	LDMIA	R13,{R0-R3}
	ADD	R0,R5,R0
	ADD	R0,R0,R1,LSL #8
0	MOV	R5,R2
1	SUBS	R5,R5,#1
	STRB	R4,[R0,R5]
	BNE	%BT1
	ADD	R0,R0,#256
	SUBS	R3,R3,#1
	BNE	%BT0
	FNRTS


mm_gfx_palset ROUT	; assumes 6-6-6 (B,G,R) palette
	FNJSR	"R4-R12"
	LDR	R2,=machinetype
	MOV	R1,#&300
	LDR	R2,[R2]
	ORR	R1,R1,#&30000
	ORR	R1,R1,#&3000000
	CMP	R2,#2
	LDR	R2,=localpalette
	MOV	R3,#256
	BLO	palette_oldstyle
0	LDRB	R4,[R0],#1
	LDRB	R5,[R0],#1
	LDRB	R6,[R0],#1
	ORR	R4,R4,R5,LSL #8
	ORR	R4,R4,R6,LSL #16
	AND	R5,R1,R4,LSL #4
	ORR	R4,R5,R4,LSL #10
	STR	R4,[R2],#4
	SUBS	R3,R3,#1
	BNE	%BT0
	LDR	R0,=paletteflag
	MOV	R1,#1
	STR	R1,[R0]
	FNRTS
palette_oldstyle
	LDR	R7,=coltable
1	LDRB	R4,[R0],#1
	LDRB	R5,[R0],#1
	LDRB	R6,[R0],#1
	MOV	R4,R4,LSR #2
	MOV	R5,R5,LSR #2
	MOV	R6,R6,LSR #2
	ORR	R4,R4,R5,LSL #4
	ORR	R4,R4,R6,LSL #8
	LDRB	R4,[R7,R4]
	STRB	R4,[R2],#1
	SUBS	R3,R3,#1
	BNE	%BT1
	LDR	R0,=dirty
	MOV	R1,#768
	MVN	R2,#0
	MVN	R3,#0
2	STMIA	R0!,{R2,R3}
	SUBS	R1,R1,#8
	BNE	%BT2
	FNRTS


	MACRO
	FNspr	$doplot
	LDR	R12,=display
	LDR	R12,[R12]
	TEQ	R12,#0
	LDMEQDB	R11,{R4-R8,R11,R13,PC}$_HAT
	STMFD	R13!,{R0-R3}
	BL	mm_gfx_setdirty
	LDMIA	R13,{R0-R3}
	ADD	R0,R12,R0
	ADD	R0,R0,R1,LSL #8
	RSB	R14,R2,#256
0	MOV	R7,R2
1	LDRB	R12,[R4],#1
	FNplot_$doplot
	SUBS	R7,R7,#1
	BNE	%BT1
	ADD	R0,R0,R14
	SUBS	R3,R3,#1
	BNE	%BT0
	LDMDB	R11,{R4-R8,R11,R13,PC}$_HAT
	MEND


; Plots a sprite of arbitrary size.
; Input: x, y, sprite, width, height
	MACRO
	FNplot_std
	STRB	R12,[R0],#1
	MEND
PlotXY	ROUT
	MOV	R12,R13
	STMFD	R13!,{R4-R8,R11,R12,R14,PC}
	SUB	R11,R12,#4
	MOV	R4,R2		; sprite
	MOV	R2,R3		; width
	LDR	R3,[R12]	; height
	FNspr	std


; Plots a masked sprite of arbitrary size.
; Input: x, y, sprite, width, height
	MACRO
	FNplot_mask
	TEQ	R12,#0
	ADDEQ	R0,R0,#1
	STRNEB	R12,[R0],#1
	MEND
PlotXYmask ROUT
	MOV	R12,R13
	STMFD	R13!,{R4-R8,R11,R12,R14,PC}
	SUB	R11,R12,#4
	MOV	R4,R2		; sprite
	MOV	R2,R3		; width
	LDR	R3,[R12]	; height
	FNspr	mask


; Plots an inked sprite of arbitrary size.
; Input: x, y, sprite, ink, paper, width, height
	MACRO
	FNplot_ink
	TEQ	R12,#0
	ADDNE	R12,R12,R5,LSL #4
	STREQB	R6,[R0],#1
	STRNEB	R12,[R0],#1
	MEND
PlotXYink ROUT
	MOV	R12,R13
	STMFD	R13!,{R4-R8,R11,R12,R14,PC}
	SUB	R11,R12,#4
	MOV	R4,R2		; sprite
	MOV	R5,R3		; ink
	LDR	R6,[R12]	; paper
	LDMIB	R12,{R2,R3}	; width, height
	FNspr	ink


; Plots a masked inked sprite of arbitrary size.
; Input: x, y, sprite, ink, paper, width, height
	MACRO
	FNplot_mask_ink
	TEQ	R12,#0
	ADDNE	R12,R12,R5,LSL #4
	STRNEB	R12,[R0],#1
	ADDEQ	R0,R0,#1
	MEND
PlotXYmask_ink ROUT
	MOV	R12,R13
	STMFD	R13!,{R4-R8,R11,R12,R14,PC}
	SUB	R11,R12,#4
	MOV	R4,R2		; sprite
	MOV	R5,R3		; ink
	LDMIA	R12,{R2,R3}	; width, height
	FNspr	mask_ink


; Plots a masked inked sprite of arbitrary size.
; Input: x, y, sprite, ink, paper, width, height
	MACRO
	FNplot_shiny
	AND	R8,R12,#15
	SUBS	R8,R8,R5
	MOVMI	R8,#0
	TEQ	R12,#0
	ANDNE	R12,R12,#240
	ORRNE	R12,R12,R8
	STRNEB	R12,[R0],#1
	ADDEQ	R0,R0,#1
	MEND
PlotShiny ROUT
	MOV	R12,R13
	STMFD	R13!,{R4-R8,R11,R12,R14,PC}
	SUB	R11,R12,#4
	MOV	R4,R2		; sprite
	MOV	R5,R3		; ink
	LDR	R2,[R12]	; size
	MOV	R3,R2
	FNspr	shiny


FadeToBlue ROUT
	FNJSR	"R4,R5,R12"
	MOV	R4,#32
	LDR	R12,=fadetable
	LDR	R5,=colourmap
0	LDRB	R1,[R12],#1
	LDRB	R2,[R12],#1
	LDR	R0,=display
	LDR	R0,[R0]
	ADD	R0,R0,R1
	MOV	R1,#128/4
	ADD	R0,R0,R2,LSL #8
1	MOV	R2,#256/4
2	LDRB	R14,[R0]
	SUBS	R2,R2,#1
	ADD	R14,R14,#16
	MOV	R14,R14,LSL #26
	LDRB	R14,[R5,R14,LSR #26]
	STRB	R14,[R0],#4
	BNE	%BT2
	ADD	R0,R0,#&300
	SUBS	R1,R1,#1
	BNE	%BT1
3	MOV	R0,#0
	MOV	R1,#0
	MOV	R2,#256
	MOV	R3,#128
	BL	mm_gfx_setdirty
	BL	mm_gfx_flush
	SUBS	R4,R4,#1
	BNE	%BT0
	FNRTS


	IMPORT	PALfade
	IMPORT	PALmain
	IMPORT	EXTRAc

	MACRO
	Black	$r
	LDRB	R12,[R1,$r]
	MUL	R12,R2,R12
	MOV	R12,R12,LSR #2
	STRB	R12,[R0,$r]
	MEND

	MACRO
	White	$r,$w
	LDRB	R12,[R1,$r]$w
	EOR	R12,R12,#255
	MUL	R12,R2,R12
	MVN	R12,R12,LSR #2
	STRB	R12,[R0,$r]$w
	MEND

RotPal2	ROUT
	FNJSR
	LDR	R0,=PALfade
	LDR	R1,=PALmain
	LDR	R2,=EXTRAc
	LDRB	R2,[R2]
	CMP	R2,#8
	BHS	rotpal_8
	RSB	R2,R2,#7
	MOV	R3,#768
	ADD	R0,R0,R3
	ADD	R1,R1,R3
0	SUBS	R3,R3,#3
	FNRTS	MI
	LDRB	R12,[R1,#-3]!
	LDRB	R14,[R1,#1]
	ADD	R12,R12,R12,LSL #2	; red*5
	ADD	R12,R12,R14
	ADD	R12,R12,R14,LSL #3	; +green*9
	LDRB	R14,[R1,#2]
	ADD	R12,R12,R14,LSL #1	; +blue*2
	MVN	R12,R12,LSR #4		; /16 & invert
	MOV	R14,#0
	TST	R2,#2
	STREQB	R14,[R0,#-3]!
	STRNEB	R12,[R0,#-3]!
	TST	R2,#4
	STREQB	R14,[R0,#1]
	STRNEB	R12,[R0,#1]
	TST	R2,#1
	STREQB	R14,[R0,#2]
	STRNEB	R12,[R0,#2]
	B	%BT0
rotpal_8
	SUB	R2,R2,#7
	MOV	R3,#768
2	SUBS	R3,R3,#1
	Black	R3
	BNE	%BT2
	FNRTS


mm_snd_hitpianokeys ROUT
	LDR	R1,=domuskey
	LDR	R1,[R0]
	TEQ	R1,#1
	MOVEQS	PC,R14
	LDR	R1,=SOUND
	LDR	R1,[R1]
	TST	R1,#2
	MOVNES	PC,R14
	FNJSR	"R4"
	LDR	R0,=timplayer_song
	LDR	R0,[R0]
	MVN	R1,#0
	SWI	&7138B ; XTimPlayer_SongPosition
	MOV	R0,R1
	MOV	R1,R2
	MOV	R2,R3
	MOV	R3,R4
	FNRTS	VS
	SUBS	R0,R0,#13
	FNRTS	LT
	ORREQ	R1,R1,#56
	ORR	R14,R1,R0,LSL #6
	CMP	R14,#256
	LDRHS	R0,=domuskey
	MOVHS	R1,#0
	STRHSB	R1,[R0]
	LDR	R1,=keydata-56*4
	LDR	R4,=key
	ADD	R1,R1,R14,LSL #2
	MOV	R3,#1
	MOV	R2,#4
	MOV	R0,#0
0	LDRB	R14,[R1],#1
	LDRB	R14,[R4,R14]
	ORR	R0,R0,R3,LSL R14
	SUBS	R2,R2,#1
	BNE	%BT0
	FNRTS


	AREA	|Asm$$Code$$0|, CODE, READONLY


Initialise ROUT
	FNJSR	"R4-R12"
	MOV	R0,#229
	MOV	R1,#1
	MOV	R2,#0
	SWI	6
	SWI	&42 ; OS_ReadMonotonicTime
	LDR	R1,=time
	STR	R0,[R1]
	MOV	R4,#320*480
	BL	claimscreenmemory
	LDRHI	R0,=hires_ok
	MOVHI	R1,#1
	STRHI	R1,[R0]
	MOVLO	R4,#320*256
	BLLO	claimscreenmemory
	LDRLO	R0,=fail
	FNRTS	LO
	MOV	R0,#16
	ADRL	R1,paletteset
 	MOV	R2,#0
	SWI	&2001F ; XOS_Claim
	MOVVC	R0,#14
	MOVVC	R1,#4
	SWIVC	&20006
	MOV	R0,#0
	FNRTS


findMachineType ROUT
	FNJSR
	MOV	R0,#129
	MOV	R1,#0
	MOV	R2,#255
	SWI	6
	CMP	R1,#165
	BLO	%FT0
	; If we reach here, we have an ARM6 or later
	MOV	R0,#0
	SWI	&2006D ; XOS_PlatformFeatures
	MOVVS	R0,#0
	TST	R0,#&40	; no 26-bit modes...
	MOVNE	R0,#4	; ... so assume XScale
	BNE	%FT1
	MOV	R0,#0
	MRS	R3,CPSR ; save PSR
	SWI	&16 ; OS_EnterOS
	& &EE100F10 ; MRC CP15,0,R0,C0,C0 ; ARM ID
	MSR	CPSR_c,R3 ; restore mode bits of PSR
	AND	R0,R0,#&FF00
	CMP	R0,#&6000
	RSBHSS	R0,R0,#&9F00
	LDR	R1,=machinetype
	MOVHS	R0,#2	; Risc PC (no SA), A7000 etc.
	MOVLO	R0,#3	; Risc PC (with SA)
1	STR	R0,[R1]
	; check if 16 bit hardware is enabled
	MOV	R0,#0
	SWI	&60144 ; XSound_Mode
	LDR	R1,=using_16bit
	MOVVS	R0,#0
	STR	R0,[R1]
	MOV	R0,#0
	FNRTS
0	ADR	R1,swi_cache
	SWI	&20039
	MOVVS	R0,#0	; Arc (ARM2/ARM250, or cache module unplugged)
	MOVVC	R0,#1	; Arc (ARM3)
	B	%BT1
swi_cache =	"Cache_0",0
	ALIGN


claimscreenmemory ROUT
	ADD	R4,R4,#81920
	MOV	R0,#2
	SWI	&5C ; OS_ReadDynamicArea
	MOV	R0,#2
	RSB	R1,R1,R4
	SWI	&2002A ; XOS_ChangeDynamicArea
	MOV	R0,#2
	SWI	&5C ; OS_ReadDynamicArea
	CMP	R1,R4
	MOV	PC,R14


SelMode	ROUT
	STMFD	R13!,{R0}
	MOV	R0,#135
	MOV	R1,#0
	MOV	R2,#0
	SWI	6 ; OS_Byte
	LDR	R0,=modedata
	LDR	R1,[R0]
	TEQ	R1,#0
	BPL	stdmode
	STR	R2,[R0],#4
	CMP	R2,#256
	BLO	stdmode
	LDMIA	R2!,{R1,R3}
	STMIA	R0!,{R1,R3}
	LDMIA	R2!,{R1,R3}
	STMIA	R0!,{R1,R3}
	LDMIA	R2!,{R1}
	STMIA	R0!,{R1}
0	LDMIA	R2!,{R1,R3}
	STMIA	R0!,{R1,R3}
	TEQ	R1,#0
	BPL	%BT0
stdmode	LDMFD	R13!,{R0}
	LDR	R1,=hires_ok
	LDR	R1,[R1]
	TEQ	R1,#0
	MOVEQ	R0,#0
	FNJSR	"R4-R11"
	LDR	R2,=hires
tryagain
	TEQ	R0,#0
	STR	R0,[R2]
	LDR	R0,=machinetype
	LDREQ	R3,=LoRes
	LDRNE	R3,=HiRes
	LDR	R0,[R0]
	CMP	R0,#2
	MOV	R0,#0
	BLO	mode_arc
	ADD	R1,R3,#12
	SWI	&20065 ; XOS_ScreenMode
	BVC	donemode
	B	mode_error
mode_arc
	SWI	&20116 ; XOS_WriteI+22
	LDRVC	R0,[R3,#8]
	SWIVC	&20000 ; XOS_WriteC
	BVS	mode_error
	MOV	R0,#135
	SWI	6 ; OS_Byte
	LDR	R0,[R3,#8]
	TEQ	R2,R0
	BEQ	donemode
mode_error
	LDR	R2,=hires
	LDR	R1,[R2]
	TEQ	R1,#0
	MOVNE	R0,#0
	STRNE	R0,[R2]
	LDRNE	R2,=hires_ok
	BNE	tryagain
	LDR	R0,=modefail
	FNRTS
donemode
	LDR	R0,=off
	MOV	R1,#10
	SWI	&20046 ; OS_WriteN
	LDR	R0,=vars
	LDR	R1,=videoram
	SWI	&31 ; OS_ReadVduVariables
	LDR	R0,[R3,#4]	; offset to top left of 'used' rectangle
	LDR	R2,[R1]
	ADD	R3,R2,R0
	LDR	R0,=hires
	STR	R3,[R1]
	LDR	R0,[R0]
	TEQ	R0,#0
	LDR	R1,=display
	ADDEQ	R3,R2,#320*256
	ADDNE	R3,R2,#320*480
	STR	R3,[R1]
	MOV	R0,#0
	FNRTS
vars	&	148,-1


openwindow ROUT
	FNJSR	"R4"
	MOV	R1,R0
	MOV	R0,#0
	LDR	R2,=&4B534154
	MOV	R3,#-1
	MOV	R4,#1
	SWI	&600C5 ; XWimp_OpenWindow
	FNRTS


areyousure ROUT
	MOV	R12,R13
	STMDB	R13!,{R4-R9,R11,R12,R14,PC}
	SUB	R11,R12,#4
	CMP	R13,R10
	BLLT	__rt_stkovf_split_small
	LDR	R14,=wimp_v
	LDR	R14,[R14]
	CMP	R14,#336
	MOVLS	R1,#3
	MOVHI	R1,#&900
	LDR	R2,=taskname
	LDRHI	R3,=taskicon
	MOVHI	R4,#1
	ADRHI	R5,rusure_btns
	LDRHI	R5,[R5,R0,LSL #2]
	ADR	R14,rusure_msgs
	LDR	R0,[R14,R0,LSL #2]
	SWI	&600DF ; XWimp_ReportError
	MOVVS	R0,#1
	ANDVC	R0,R1,#1
	LDMDB	R11,{R4-R9,R11,R13,PC}$_HAT

rusure_msgs	&	rusure_msg_Q, rusure_msg_L
rusure_btns	&	rusure_btn_Q, rusure_btn_L


godesktop
goshutdown ROUT
	FNJSR	"R0-R6,R9"
	MOV	R0,#16
	ADRL	R1,paletteset
	MOV	R2,#0
	SWI	&20020 ; XOS_Release
	MOVVC	R0,#13
	MOVVC	R1,#4
	SWIVC	&20006
;;;	ADRL	R0,volctrl
;;;	LDR	R1,=VOLUME
;;;	SWI	&2003D ; XOS_RemoveTickerEvent
;	LDR	R0,=display
;	LDMIA	R0,{R1,R2}
;	TEQ	R2,#0
;	BEQ	nobank0
;	CMP	R1,R2
;	STRHI	R2,[R0]
;	MOV	R1,#0
;	STR	R1,[R0,#4]
	LDR	R2,=using_16bit
	LDR	R2,[R2]
	CMP	R2,#0
	LDRNE	R1,=timplayer_code
	MOVNE	R0,#1
	LDRNE	R1,[R1]
	MOVNE	R2,#0
	SWINE	&60145 ; XSound_LinearHandler
	LDR	R0,=SOUND
	LDR	R0,[R0]
	TST	R0,#2
	BNE	%FT1
	LDR	R4,=timplayer_song
	LDR	R0,[R4]
	SWI	&7138A ; XTimPlayer_SongStop
	MOV	R1,#0
	LDR	R0,[R4]
	STR	R1,[R4]
	SWI	&71383 ; XTimPlayer_SongUnload
1	LDR	R0,=sndcon
	LDMIA	R0,{R0-R3}
	MOV	R4,#0
	SWI	&60140 ; XSound_Configure
	LDR	R1,=modedata
	LDR	R0,[R1],#4
	MOV	R2,#-1
	STR	R2,[R1,#-4]
	TEQ	R0,#0
	BMI	nobank0
	CMP	R0,#256
	MOVHS	R0,R1
	SWI	&600E3 ; XWimp_SetMode
nobank0	MOV	R4,#3
	LDR	R7,=oldsound
0	LDRB	R1,[R7,R4]
	ADD	R0,R4,#1
	MOV	R1,R1,LSL #24
	MOV	R1,R1,ASR #24
	SWI	&60142 ; XSound_Stereo
	SUBS	R4,R4,#1
	BPL	%BT0
	MOV	R0,#21
	MOV	R1,#0
	SWI	&20006	; flush kbd
	FNRTS

initmusic ROUT
	FNJSR	"R4-R12"
	MOV	R12,R0
	MOV	R0,#0
	MOV	R1,#0
	MOV	R2,#0
	MOV	R3,#0
	MOV	R4,#0
	SWI	&60140 ; XSound_Configure
	LDR	R7,=sndcon
	STMIA	R7,{R0-R3}
	; store stereo
	LDR	R7,=oldsound
	MOV	R4,#4
0	MOV	R0,R4
	MVN	R1,#127
	SWI	&60142 ; XSound_Stereo
	SUBS	R4,R4,#1
	STRB	R1,[R7,R4]
	BNE	%BT0
	TEQ	R12,#0
	BNE	%FT1
	MOV	R0,#0
	MOV	R1,#0
	SWI	&60142 ; XSound_Stereo
	MOV	R0,#1
	MOV	R1,#0
	SWI	&60142 ; XSound_Stereo
	MOV	R0,#0
	FNRTS
	; start tune
1	ADR	R0,ensure
	SWI	&20005 ; XOS_CLI
	BLVS	loadmodule
	BVS	%FT2
	LDR	R8,=SOUND
	LDR	R8,[R8]
	MOV	R0,R8,LSR #2
	CMP	R0,#1
	MOVLO	R1,#72
	MOVEQ	R1,#48
	MOVHI	R1,#24
	MOV	R0,#0
	SWI	&71381 ; XTimPlayer_Configure (sample period)
	BVS	%FT2
	MOV	R0,#1
	AND	R1,R8,#1
	SWI	&71381 ; XTimPlayer_Configure (interpolation)
	; also volume ramping if interpolation?
	MOV	R0,#&100
	SWI	&71381 ; XTimPlayer_Configure (volume ramping)
	SWI	&606C0 ; XHourglass_On
	MOV	R1,R12
	SWI	&71382 ; XTimPlayer_SongLoad
	LDRVC	R1,=timplayer_song
	STRVC	R0,[R1]
	SWIVC	&606C1 ; XHourglass_Off
	MOVVC	R1,#17
	SWIVC	&7138B ; XTimPlayer_SongPosition
	SWIVC	&71388 ; XTimPlayer_SongPlay
	BLVC	musicVolume
	MOVVC	R0,#0
	FNRTS	VC
2	MOV	R0,#1
	FNRTS
loadmodule
	MOV	R0,#1
	ADR	R1,timplayer_name
	SWI	&2001E ; XOS_Module
	BVC	%BT1 ; loaded module, so retry
	B	%BT2
ensure	=	"%RMEnsure TimPlayer 0.87",0
timplayer_name
	=	"<Manic$Dir>.TimPlayer",0
	ALIGN


initsfx ROUT
	FNJSR	"R4-R12"
	MOV	R12,R0
;;;	MOV	R0,#2
;;;	ADRL	R1,volctrl
;;;	LDR	R2,=VOLUME
;;;	SWI	&2003C ; XOS_CallEvery
	; find timplayer handler and replace it
;	MOV	R1,#0
	LDR	R2,=SOUND
	LDR	R2,[R2]
	MOV	R2,R2,LSR #2
	CMP	R2,#1
	LDR	R3,=dmasize
	MOVLO	R1,#336 ; (1024/3)&~15
	MOVLO	R2,#72
	MOVEQ	R1,#512
	MOVEQ	R2,#48
	MOVHI	R1,#1024
	MOVHI	R2,#24
	STR	R1,[R3]
	LDR	R3,=using_16bit
	MOV	R4,#0
	LDR	R3,=using_16bit
	LDR	R3,[R3]
	CMP	R3,#0
	BNE	%FT1
	; 8-bit variant
	TEQ	R12,#0
	MOVEQ	R0,#4
	MOVNE	R0,#2
	ADREQL	R3,mySoundCode
	ADRNEL	R3,mySoundCode_nomusic
	MOV	R7,R2
	SWI	&60140 ; XSound_Configure
	MOV	R2,R7
	LDRVC	R3,[R3]
	LDRVC	R7,=timplayer_code
	STRVC	R3,[R7]
	BVS	%FT2
	LDR	R3,=1000000
	MOV	R4,#0
0	SUBS	R3,R3,R2
	ADDGE	R4,R4,#1
	BGE	%BT0
	LDR	R3,=samplefreq
	STR	R4,[R3]
	MOV	R0,#1
	MOV	R1,#0
	SWI	&60142 ; XSound_Stereo
	MOV	R0,#2
	MOV	R1,#0
	SWI	&60142 ; XSound_Stereo
	MOV	R0,#3
	MOV	R1,#0
	SWI	&60142 ; XSound_Stereo
	MOV	R0,#4
	MOV	R1,#0
	SWI	&60142 ; XSound_Stereo
	MOV	R0,#0
	FNRTS
	; 16-bit variant
1	MOV	R0,#0
	MOV	R3,#0
	SWI	&60140 ; XSound_Configure
	LDR	R7,=SOUND
	LDR	R7,[R7]
	TST	R7,#2
	CMPEQ	R12,#0
	LDREQ	R0,=timplayer_song
	MOVEQ	R1,#&80
	LDREQ	R0,[R0]
	SWIEQ	&7138C ; XTimPlayer_SongVolume
	BVS	%FT2
3	MOV	R0,#1
	ADRL	R1,go_vfill16
	MOV	R2,#0
	SWI	&60145 ; XSound_LinearHandler
	LDRVC	R7,=timplayer_code
	STRVC	R1,[R7]
	BVS	%FT2
	MOV	R0,#1
	SWI	&60146 ; XSound_SampleRate
	MOVVC	R4,R2,LSR #10
	LDRVC	R3,=samplefreq
	STRVC	R4,[R3]
	MOVVC	R0,#0
2	MOVVS	R0,#1
	FNRTS


	AREA	|Asm$$Code$$1|, CODE, READONLY


musicPlay ROUT
	MOV	R3,#1
musicPlayB
	FNJSR	"R4-R5"
	LDR	R1,=SOUND
	LDR	R1,[R1]
	TST	R1,#2
	MOVNE	R3,#0
	LDR	R1,=playing
	STR	R3,[R1]
	LDR	R12,=domuskey
	STR	R2,[R12]
	MOV	R1,R0
	LDR	R0,=timplayer_song
	LDR	R0,[R0]
	SWI	&7138B ; XTimPlayer_SongPosition
	MOV	R0,R1
	MOV	R1,R2
	MOV	R2,R3
	MOV	R3,R4
	FNRTS


mm_snd_getmodpos ROUT
	FNJSR	"R4"
  	LDR	R0,=timplayer_song
	LDR	R0,[R0]
	MVN	R1,#0
	SWI	&7138B ; XTimPlayer_SongPosition
	MOVVC	R0,R1
	MOVVS	R0,#0
	FNRTS


mm_snd_active ROUT
	LDR	R0,=playing
	LDR	R0,[R0]
	MOV	PC,R14


musicPause ROUT
	LDR	R1,=SOUND
	LDR	R1,[R1]
	TST	R1,#2
	MOVNE	R0,#0
	LDR	R1,=playing
	STR	R0,[R1]
	MOVS	PC,R14

musicVolume ROUT
	FNJSR
	LDR	R0,=timplayer_song
	LDR	R1,=VOLUME
	LDR	R0,[R0]
	LDR	R1,[R1]
	ADRL	R2,volscale+101
	LDRB	R1,[R2,R1] ; *2.55
	LDR	R2,=using_16bit
	LDR	R2,[R2]
	TEQ	R2,#0
	MOVNE	R1,R1,LSR #1
	SWI	&7138C ; XTimPlayer_SongVolume
	FNRTS


paletteset ROUT
	TEQ	R0,#4
	MOVNES	PC,R14
	FNJSR	"R1-R5"
	LDR	R2,=paletteflag
	LDR	R1,[R2]
	TEQ	R1,#0
	BEQ	dokeyboard
	MOV	R1,#0
	STR	R1,[R2]
	LDR	R1,=machinetype
	LDR	R1,[R1]
	TEQ	R1,#2
	BNE	paletteset_slow
	MOV	R5,#&3500000	; direct VIDC20 access
	MOV	R4,#0
	LDR	R3,=localpalette
	ADD	R3,R3,#1
0	LDR	R1,[R3],#4
	ORR	R1,R1,R4,LSL #24
	BIC	R1,R1,#&F<<28
	STR	R1,[R5]
	ADD	R4,R4,#1
	TEQ	R4,#256
	BNE	%BT0
	B	dokeyboard
paletteset_slow
	TEQ	R1,#4
	BEQ	paletteset_xscale
	MOV	R4,PC
	ORR	R5,R4,#3
	TEQP	R5,#0
	ADR	R0,paletteset_callback
	STMFD	R13!,{R14}
	SWI	&20054 ; XOS_AddCallBack
	LDMFD	R13!,{R14}
	TEQP	R4,#0
dokeyboard
	MOV	R0,#4
	FNRTS
paletteset_xscale
	MRS	R4,CPSR
	ORR	R5,R4,#3	; is this the right mode, or even necessary?
	MSR	CPSR_c,R5
	ADR	R0,paletteset_callback
	STMFD	R13!,{R14}
	SWI	&20054 ; XOS_AddCallBack
	LDMFD	R13!,{R14}
	MSR	CPSR_c,R4
	MOV	R0,#4
	FNRTS

paletteset_callback
	FNJSR	"R0-R5"
	MVN	R0,#0
	MVN	R1,#0
	LDR	R2,=localpalette
	MOV	R3,#1024
	MOV	R4,#0
	MOV	R5,#0
	MOV	R6,#0
	SWI	&6075D ; XColourTrans_WritePalette
	FNRTS


mm_keyb_pressed
	TEQ	R0,#255
	BEQ	anykey
	TST	R0,#128
	LDREQ	R1,=keymap
	LDREQB	R1,[R1,R0]
	RSBNE	R1,R0,#384
	MOV	R0,#129
	MOV	R2,#255
	SWI	&20006
	MOV	R0,R1
mm_keyb_update
	MOVS	PC,R14
anykey
	MOV	R0,#129
	MOV	R1,#256-129
	MOV	R2,#255
	SWI	&20006
	RSB	R0,R1,#255
	MOVS	PC,R14


;volctrl	FNJSR	"R0-R3"
;	MOV	R0,#129
;	MOV	R1,#-59:AND:255
;	MOV	R2,#255
;	SWI	&20006
;	ANDVC	R3,R1,#128
;	MOVVC	R0,#129
;	MOVVC	R1,#-60:AND:255
;	MOVVC	R2,#255
;	SWIVC	&20006
;	FNRTS	VS
;	SUBCS	R3,R3,#128
;	TEQ	R3,#0
;	FNRTS	EQ
;	LDR	R0,[R12]
;	ADD	R0,R0,R3,ASR #7
;	CMP	R0,#100
;	STRLS	R0,[R12]
;	BLLS	musicVolume
;	FNRTS


	AREA	|Asm$$Code2|, CODE, READONLY


mySoundCode
	&	go_vfill, 0, 0, 0

mySoundCode_nomusic
	&	go_vfill_nomusic, 0, 0, 0

go_vfill ROUT
	FNJSR	"R12"
	LDR	R14,=playing
	LDR	R14,[R14]
	TEQ	R14,#0
	BNE	%FT0 ; 32-bit compliant
	BL	callNullPlayer
	B	%FT1
0	BL	callTimPlayer
1	ADD	R12,R12,#2
	MOV	R1,#0
	LDR	R9,=voice1data
	BL	vfill
	LDR	R12,[R13]
	MOV	R1,#1
	LDR	R9,=voice2data
	ADD	R12,R12,#3
	BL	vfill
	FNRTS

go_vfill_nomusic ROUT
	FNJSR	"R12"
	LDR	R0,=dmaoffset
	MOV	R1,#DMASIZE
	STR	R1,[R0]
	LDR	R9,=voice1data
	BL	vfill
	LDR	R12,[R13]
	MOV	R1,#1
	LDR	R9,=voice2data
	ADD	R12,R12,#1
	BL	vfill
	FNRTS

callTimPlayer ROUT
;	FNJSR	"R10-R12"
;	SUB	R10,R10,R12
;	ADD	R10,R12,R10,LSR #1
;	MOV	R11,#2
;	BL	%FT0
;	LDMFD	R13,{R10-R12}
;	SUB	R11,R10,R12
;	ADD	R11,R12,R11,LSR #1
;1	LDR	R0,[R11,#-4]!
;	MOV	R1,R0,LSR #16
;	STMDB	R10!,{R0,R1}
;	CMP	R10,R12
;	BHI	%BT1
;	FNRTS
;0	LDR	R0,=timplayer_code
;	LDR	PC,[R0]
	FNJSR	"R0-R2,R10-R12"
	LDR	R0,=dmaoffset
	LDR	R1,=dmabuffer
	LDR	R0,[R0]
0	TEQ	R0,#DMASIZE
	BLEQ	callTimPlayer_internal
	LDR	R2,[R1,R0]
	ADD	R0,R0,#4
	MOV	R11,R2,LSR #16
	STMIA	R12!,{R2,R11}
	CMP	R12,R10
	BLO	%BT0
	LDR	R1,=dmaoffset
	STR	R0,[R1]
	FNRTS
callTimPlayer_internal ROUT
	LDMIA	R13,{R0-R2}
	FNJSR	"R10-R12"
	LDR	R12,=dmabuffer		; we need to refill
	MOV	R11,#2
	ADD	R10,R12,#DMASIZE
	BL	%FT0
	MOV	R0,#0
	LDR	R1,=dmabuffer
	FNRTS
0	LDR	R0,=timplayer_code
	LDR	PC,[R0]

callNullPlayer ROUT
	FNJSR	"R12"
	MOV	R14,#0
0	STR	R14,[R12],#4
	CMP	R12,R10
	BLO	%BT0
	FNRTS

vfilled	ROUT
	MOV	R0,#0
0	CMP	R12,R10
	STRLTB	R0,[R12],R11
	BLT	%BT0
	B	vreturn

vfill	ROUT
	FNJSR
	LDR	R5,=wavsample
	LDRB	R0,[R5,R1]	; sample number
	TST	R0,#128
	BNE	notnewsample
	MOV	R4,#128
	STRB	R4,[R5,R1]
	LDR	R2,=sampleptr
	ADD	R0,R0,R0,LSL #1
	LDR	R0,[R2,R0,LSL #2]!
	LDMIB	R2,{R2,R3}
	ADD	R5,R9,#12
	STMIA	R5,{R0,R2,R3}	; sample ptr, end, repeat len
	MOV	R0,#0
notnewsample
	LDR	R1,=wavpitch
	LDMIA	R9,{R2-R8}
	LDR	R0,[R1,R3,LSL #2]
	MOVS	R0,R0,LSL #16
	BEQ	vfilled
	MOV	R2,R2,LSR #16
	MOV	R2,R2,LSL #16
	ORR	R2,R2,R0,LSR #16	; pitch bend support
	LDR	R1,=wavlen
	LDR	R4,=VOLUME
	LDR	R0,[R1,R3,LSL #2]
	LDR	R4,[R4]
	TEQ	R0,#0
	MOVNE	R8,R0
	MOVNE	R0,#0
	STRNE	R0,[R1,R3,LSL #2]	; actual note length
	ADRL	R0,volscale
	LDRB	R4,[R0,R4]
0	CMP	R5,R6
	SUBHS	R5,R5,R7
	CMPHS	R5,R6
	BHS	vfilled
	SUBS	R8,R8,#1
	BMI	vfilled
	ADD	R2,R2,R2,LSL #16
	LDRB	R0,[R5],R2,LSR #28
	BIC	R2,R2,#(-1)<<28
	SUBS	R0,R0,R4,LSL #1
	MOVMI	R0,#0
	STRB	R0,[R12],R11
	CMP	R12,R10
	BLT	%BT0
vreturn	STR	R2,[R9]
	STR	R5,[R9,#12]
	STR	R8,[R9,#24]
	FNRTS

go_vfill16 ROUT
	FNJSR	"R11-R12"
	LDR	R14,=SOUND
	LDR	R14,[R14]
	MVN	R14,R14
	TST	R14,#2
	LDRNE	R14,=playing
	LDRNE	R14,[R14]
	TEQNE	R14,#0
	BNE	%FT0 ; 32-bit compliant
	BL	callNullPlayer16
	B	%FT1
0	BL	callTimPlayer16
1	MOV	R10,R2
	MOV	R12,R1
	LDR	R0,=SOUND
	MOV	R1,#0
	LDRB	R0,[R0]
	LDR	R9,=voice1data
	TST	R0,#2
	MOVEQ	R8,#10
	MOVNE	R8,#9
	BL	vfill16
	LDR	R0,=SOUND
	MOV	R1,#1
	LDRB	R0,[R0]
	LDR	R9,=voice2data
	TST	R0,#2
	MOVEQ	R8,#10
	MOVNE	R8,#9
	BL	vfill16
	FNRTS

callTimPlayer16 ROUT
	FNJSR	"R0-R5"
	BL	%FT0
	FNRTS
0	LDR	R5,=timplayer_code
	LDR	PC,[R5]

callNullPlayer16 ROUT
	FNJSR	"R1"
	MOV	R14,#0
0	STR	R14,[R1],#4
	CMP	R1,R2
	BLO	%BT0
	FNRTS

vfill16	ROUT
	FNJSR	"R8,R10,R12"
	LDR	R5,=wavsample
	LDRB	R0,[R5,R1]	; sample number
	TST	R0,#128
	BNE	notnewsample16
	MOV	R4,#128
	STRB	R4,[R5,R1]
	LDR	R2,=sampleptr
	ADD	R0,R0,R0,LSL #1
	LDR	R0,[R2,R0,LSL #2]!
	LDMIB	R2,{R2,R3}
	ADD	R5,R9,#12
	STMIA	R5,{R0,R2,R3}	; sample ptr, end, repeat len
	MOV	R0,#0
notnewsample16
	LDR	R1,=wavpitch
	LDMIA	R9,{R2-R8}
	LDR	R0,[R1,R3,LSL #2]
	MOVS	R0,R0,LSL #16
	BEQ	vreturn16
	MOV	R2,R2,LSR #16
	MOV	R2,R2,LSL #16
	ORR	R2,R2,R0,LSR #16	; pitch bend support
	LDR	R1,=wavlen
	LDR	R4,=VOLUME
	LDR	R0,[R1,R3,LSL #2]
	LDR	R4,[R4]
	TEQ	R0,#0
	MOVNE	R8,R0
	MOVNE	R0,#0
	STRNE	R0,[R1,R3,LSL #2]	; actual note length
	LDR	R3,[R13]
0	CMP	R5,R6
	SUBHS	R5,R5,R7
	CMPHS	R5,R6
	BHS	vreturn16
	SUBS	R8,R8,#1
	BMI	vreturn16
	ADD	R2,R2,R2,LSL #16
	LDRB	R0,[R5],R2,LSR #28
	BIC	R2,R2,#(-1)<<28
	MOV	R0,R0,LSL #24
	MOV	R11,R0,ASR R3	; cf 8- to 16-bit and 1/4 channels and l-r
	MUL	R0,R11,R4	; volume scaling
	LDR	R11,[R12]
	ADD	R11,R0,R11,ROR #16
	ADD	R11,R0,R11,ROR #16
	STR	R11,[R12],#4
	CMP	R12,R10
	BLT	%BT0
vreturn16
	STR	R2,[R9]
	STR	R5,[R9,#12]
	STR	R8,[R9,#24]
	FNRTS


module_present
	FNJSR	"R4,R5"
	MOV	R1,R0
	MOV	R0,#18
	SWI	&2001E ; XOS_Module
	MOVVC	R0,#1
	MOVVS	R0,#0
	FNRTS


uriDispatch
	MOVS	R2,R1
	MOV	R1,R0
	MOVEQ	R0,#0
	MOVNE	R0,#1
	SWI	&6E381 ; XURI_Dispatch
	MOVVC	R0,#0
	MOVS	PC,R14


uriRequest
	MOV	R3,R2
	MOV	R2,R1
	MOV	R1,R0
	MOV	R0,#0
	SWI	&6E382 ; XURI_RequestURI
	MOVVC	R0,R2
	MOVVS	R0,#0
	MOVS	PC,R14


	AREA	|Asm$$ROData|, DATA, READONLY

volscale
	BIN	systems.riscos.data.volscale
	ALIGN

LoRes	&	320*256, 32*320+32, 13
	&	1, 320,256, 3, -1, 3,255, 4,2, 5,2, -1

HiRes	&	320*480, 48*320+32, 49
	&	1, 320,480, 3, -1, 3,255, 4,2, -1

fail	=	"Manic Miner cannot start up: not enough memory for its screen display.",0

modefail =	"Manic Miner cannot start up: ensure that a 320x256 mode is available.",0
	ALIGN

off	=	23,1,0,0,0,0,0,0,0,0
	ALIGN

rusure_msg_Q	=	"    A game is currently in progress. "
		=	"Are you sure that you wish to quit?",0
		ALIGN
rusure_msg_L	=	"    A game is currently in progress. "
		=	"Are you sure that you wish to load a new set of levels?",0
rusure_btn_Q	=	"Quit,Continue",0
rusure_btn_L	=	"Load,Keep current",0
taskname	=	"Manic Miner",0
taskicon	=	"!manic",0
	ALIGN

keymap
	MACRO
	Key  $a,$b,$c,$d,$e,$f,$g,$h
	=    255-$a, 255-$b, 255-$c, 255-$d, 255-$e, 255-$f, 255-$g, 255-$h
	MEND
	Key	127,112, 48, 49, 17, 18, 19, 52
	Key	 36, 21, 38, 39, 23, 47, 93, 96
	Key	 16, 33, 34, 51, 35, 68, 53, 37
	Key	 54, 55, 56, 88, 73,  4, 65, 81
	Key	 50, 67, 83, 84, 69, 70, 86, 87
	Key	 79, 45,  0, 94, 97, 66, 82, 99
	Key	100, 85,101,102,103,104,  6, 91
	Key	  5, 98, 64,113,114,115, 20,116
	Key	117, 22,118,119, 30, 77, 31, 27
	Key	 42, 43, 59,122,123, 26, 58,107
	Key	124,108,106, 76,127,127,120, 28
	Key	 29,127,127,127,127,127,127,127
	Key	 60,  7, 74, 32,  8, 44, 62, 57
	Key	 63, 25,121,105, 41, 78, 61, 89
	Key	127,127,127,127,127,127,127,127
	Key	127,127,127,127,127,127,127,127

fadetable
	; xoff, yoff
	=	0,0, 2,2, 0,2, 2,0
	=	3,0, 1,2, 3,2, 1,0
	=	1,1, 3,3, 1,3, 3,1
	=	2,1, 0,3, 2,3, 0,1
	=	0,1, 2,3, 0,3, 2,1
	=	3,1, 1,3, 3,3, 1,1
	=	1,0, 3,2, 1,2, 3,0
	=	2,0, 0,2, 2,2, 0,0

colourmap
	= 26,23,21,19,18,19,20,20,20,20,19,21,23,26,20,16 ; 240-255
	= 31,30,24,21,21,20,19,19,31,30,23,21,21,19,18,16 ; 0-15
	= 16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31 ; others
	= 16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31

coltable
	BIN	systems.riscos.data.ColTable
	ALIGN

;		C  C# D  D# E  F  F# G  G# A  A# B
key	=	32
	=	32,32,32,32,32,32,32,32,32,32,32,32
	=	32,32,32,32,32,32,32,32,32,32,32,32
	=	32,32,32,32,32,32,32, 0, 0, 1, 1, 2
	=	 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 8, 9
	=	10,10,11,11,12,13,13,14,14,15,15,16
	=	17,17,18,18,19,20,20,21,21,22,22,23
	=	24,24,25,25,26,27,27,28,28,29,29,30
	=	31,31,32,32,32,32,32,32,32,32,32,32
	=	32
	ALIGN

keydata	=	61,61, 0, 0 ;13
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	65,65, 0, 0
	=	65,65, 0, 0
	=	68,68, 0, 0
	=	68,68, 0, 0
	=	68,68,37, 0 ;14
	=	68,68,37, 0
	=	 0, 0,56,65
	=	 0, 0,56,65
	=	77,80,56,65
	=	77,80,56,65
	=	77,80,32, 0
	=	77,80,32, 0
	=	 0, 0,56,65
	=	 0, 0,56,65
	=	73,77,56,65
	=	73,77,56,65
	=	73,77,37, 0
	=	73,77,37, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	65,65, 0, 0
	=	65,65, 0, 0
	=	68,68, 0, 0
	=	68,68, 0, 0
	=	68,68,32, 0
	=	68,68,32, 0
	=	 0, 0,56,60
	=	 0, 0,56,60
	=	75,80,56,60
	=	75,80,56,60
	=	75,80,39, 0
	=	75,80,39, 0
	=	 0, 0,56,60
	=	 0, 0,56,60
	=	72,78,56,60
	=	72,78,56,60
	=	72,78,32, 0
	=	72,78,32, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	66,66, 0, 0
	=	66,66, 0, 0
	=	70,70, 0, 0
	=	70,70, 0, 0
	=	70,70,32, 0
	=	70,70,32, 0
	=	 0, 0,56,60
	=	 0, 0,56,60
	=	78,82,56,60
	=	78,82,56,60
	=	78,82,39, 0
	=	78,82,39, 0
	=	 0, 0,56,60
	=	 0, 0,56,60
	=	75,78,56,60
	=	75,78,56,60
	=	75,78,32, 0
	=	75,78,32, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	63,63, 0, 0 ;15
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	66,66, 0, 0
	=	66,66, 0, 0
	=	70,70, 0, 0
	=	70,70, 0, 0
	=	70,70,37, 0
	=	70,70,37, 0
	=	 0, 0,56,61
	=	 0, 0,56,61
	=	77,82,56,61
	=	77,82,56,61
	=	77,82,32, 0
	=	77,82,32, 0
	=	 0, 0,56,61
	=	 0, 0,56,61
	=	73,77,56,61
	=	73,77,56,61
	=	73,77,37, 0
	=	73,77,37, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	65,65, 0, 0
	=	65,65, 0, 0
	=	68,68, 0, 0
	=	68,68, 0, 0
	=	73,73,37, 0
	=	73,73,37, 0
	=	 0, 0,56,65
	=	 0, 0,56,65
	=	80,85,56,65
	=	80,85,56,65
	=	80,85,32, 0
	=	80,85,32, 0
	=	 0, 0,56,65
	=	 0, 0,56,65
	=	77,80,56,65
	=	77,80,56,65
	=	77,80,37, 0
	=	77,80,37, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	61,61, 0, 0
	=	65,65, 0, 0
	=	65,65, 0, 0
	=	68,68, 0, 0
	=	68,68, 0, 0
	=	73,73,42, 0
	=	73,73,42, 0
	=	 0, 0,58,61
	=	 0, 0,58,61
	=	82,85,58,61
	=	82,85,58,61
	=	82,85,49, 0
	=	82,85,49, 0
	=	 0, 0,58,61 ;16
	=	 0, 0,58,61
	=	78,82,58,61
	=	78,82,58,61
	=	78,82,42, 0
	=	78,82,42, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	63,63, 0, 0
	=	66,66, 0, 0
	=	66,66, 0, 0
	=	70,70, 0, 0
	=	70,70, 0, 0
	=	70,70,32, 0
	=	70,70,32, 0
	=	70,70,56,60
	=	70,70,56,60
	=	70,70,56,60
	=	70,70,56,60
	=	70,70,39, 0
	=	68,68,39, 0
	=	67,67,56,60
	=	67,67,56,60
	=	68,68,56,60
	=	68,68,56,60
	=	77,77,37,60
	=	77,77,37,60
	=	77,77,56,61
	=	77,77,56,61
	=	77,77,56,61
	=	77,77,56,61
	=	77,77,32, 0
	=	77,77,32, 0
	=	73,70,56,61
	=	73,70,56,61
	=	70,66,56,61
	=	70,66,56,61
	=	66,63,30,58
	=	66,63,30,58
	=	66,63, 0, 0
	=	66,63, 0, 0
	=	65,61, 0, 0
	=	65,61, 0, 0
	=	70,66,32,60
	=	70,66,32,60
	=	70,66, 0, 0
	=	70,66, 0, 0
	=	68,65, 0, 0
	=	68,65, 0, 0
	=	61,56,37,53
	=	61,56, 0, 0
	=	61,56, 0, 0
	=	61,56,37, 0
	=	61,56,37, 0
	=	61,56,37, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0
	=	 0, 0, 0, 0 ;17


	AREA	|Asm$$Data|, DATA

bank		&	1
modeinit	&	1

oldsound	=	128,128,128,128

samplefreq	&	20000

voice1data	&	0,0,0,0,0,0,0
voice2data	&	0,1,0,0,0,0,0

VOLUME		&	100

	AREA	|Asm$$ZIData|, DATA, NOINIT

hires		&	0
hires_ok	&	0

videoram	&	0
display		&	0

timplayer_code	&	0
timplayer_song	&	0

using_16bit	&	0
sndcon		&	0,0,0,0
dmasize		&	0
dmaoffset	&	0

time		&	0

wavpitch	%	2*4
wavlen		%	2*4
wavsample	%	2
		%	2
domuskey	&	0
SOUND		&	0
sampleptr	%	4*3*4

paletteflag	&	0
localpalette	%	1024
last_cls	&	0

playing		&	0

machinetype	&	0

modedata	%	256

dirty		%	768

dmabuffer	%	DMASIZE

	END
